'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Layout = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _antd = require('antd');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Layout = function (_React$Component) {
    _inherits(Layout, _React$Component);

    function Layout(props) {
        _classCallCheck(this, Layout);

        return _possibleConstructorReturn(this, (Layout.__proto__ || Object.getPrototypeOf(Layout)).call(this, props));
    }

    _createClass(Layout, [{
        key: 'renderByRow',
        value: function renderByRow() {
            var colList = this.getColList();
            var colCount = colList.length;

            var style = this.props.style || { marginBottom: 8 };
            var gutter = this.props.gutter || 0;

            var childrenComp = [];
            var rowChildrenComp = [];

            var childCount = this.getChildCount();
            _react2.default.Children.map(this.props.children, function (child, index) {

                var colIndex = index % colCount;
                var spans = colList[colIndex];

                rowChildrenComp.push(_react2.default.createElement(
                    _antd.Col,
                    { span: spans },
                    child
                ));
                if (colIndex === colCount - 1 || index === childCount - 1) {
                    childrenComp.push(_react2.default.createElement(
                        _antd.Row,
                        { style: style, gutter: gutter },
                        rowChildrenComp
                    ));

                    rowChildrenComp = [];
                }
            });

            return childrenComp;
        }
    }, {
        key: 'renderByCol',
        value: function renderByCol() {
            var colList = this.getColList();
            var colCount = colList.length;

            var colStyle = this.props.colStyle || { marginBottom: 8 };

            var colChildrenComp = [];
            var childrenComp = [];

            var childCount = this.getChildCount();
            _react2.default.Children.map(this.props.children, function (child, index) {

                var colIndex = index % colCount;

                if (typeof colChildrenComp[colIndex] === 'undefined') {
                    colChildrenComp[colIndex] = [];
                }
                colChildrenComp[colIndex].push(_react2.default.createElement(
                    'div',
                    null,
                    child
                ));
            });

            if (colChildrenComp.length > 0) {
                childrenComp = _react2.default.createElement(
                    _antd.Row,
                    null,
                    colChildrenComp.map(function (col, colIndex) {

                        var spans = colList[colIndex];
                        return _react2.default.createElement(
                            _antd.Col,
                            { span: spans },
                            col
                        );
                    })
                );
            }

            return childrenComp;
        }
    }, {
        key: 'getColList',
        value: function getColList() {
            var cols = this.props.cols || 1,
                colCount = void 0,
                colList = void 0;
            if (Array.isArray(cols)) {
                colCount = cols.length;
                colList = cols;
            } else {
                colCount = +cols;
                var spanPerCol = 24 / colCount;

                colList = [];

                for (var i = 0; i < colCount; i++) {
                    colList.push(spanPerCol);
                }
            }

            return colList;
        }
    }, {
        key: 'getChildCount',
        value: function getChildCount() {
            return _react2.default.Children.count(this.props.children) || 0;
        }
    }, {
        key: 'render',
        value: function render() {
            var _props = this.props,
                mode = _props.mode,
                className = _props.className,
                style = _props.style;


            var childrenComp = void 0;
            if (mode === 'col') {
                childrenComp = this.renderByCol();
            } else {
                childrenComp = this.renderByRow();
            }

            return _react2.default.createElement(
                'div',
                { className: className, style: style },
                childrenComp
            );
        }
    }]);

    return Layout;
}(_react2.default.Component);

exports.Layout = Layout;
exports.default = Layout;